﻿using System;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace OverTimeConverTool
{
    class CSVFileHelper
    {
        /// <summary>
        /// 读取CSV文件
        /// </summary>
        /// <param name="filePath">路径</param>
        /// <returns></returns>
        public static DataTable OpenCSV(string filePath)
        {
            try
            {
                Encoding encoding = Encoding.Default;
                DataTable dt = new DataTable();
                FileStream fs = new FileStream(filePath, FileMode.Open, FileAccess.Read);
                StreamReader sr = new StreamReader(fs, encoding);
                //记录每次读取的一行记录
                string strLine = "";
                //记录每行记录中的各字段内容
                string[] aryLine = null;
                string[] tableHead = null;
                //标示列数
                int columnCount = 0;
                //标示是否是读取的第一行
                bool IsFirst = true;
                //逐行读取CSV中的数据
                while ((strLine = sr.ReadLine()) != null)
                {
                    if (IsFirst == true)
                    {
                        tableHead = strLine.Split(',');
                        IsFirst = false;
                        columnCount = tableHead.Length - 1;//读取第一行的时候，实际多了一列
                                                           //创建列
                        for (int i = 0; i < columnCount; i++)
                        {
                            DataColumn dc = new DataColumn(tableHead[i]);
                            dt.Columns.Add(dc);
                        }
                    }
                    else
                    {
                        aryLine = strLine.Split(',');
                        DataRow dr = dt.NewRow();
                        for (int i = 0; i < columnCount; i++)
                        {
                            dr[i] = aryLine[i];
                        }
                        dt.Rows.Add(dr);
                    }
                }
                //if (aryLine != null && aryLine.Length > 0)
                //{
                //    dt.DefaultView.Sort = tableHead[0] + " " + "asc";
                //}
                sr.Close();
                fs.Close();
                return dt;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
            return null;
        }

    }
}
