﻿using Microsoft.Office.Core;
using Microsoft.Office.Interop.Excel;
using System;
using System.Collections.Generic;
using System.Data;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading;

namespace SearchWordFromJavaTool
{
    class ExcelHelper
    {
        public static void ExportExcel(System.Data.DataTable dt)
        {
            if (dt == null || dt.Rows.Count == 0)
                return;
            Application xlApp = new Application();
            if (xlApp == null)
                return;
            CultureInfo CurrentCI = Thread.CurrentThread.CurrentCulture;
            Thread.CurrentThread.CurrentCulture = new CultureInfo("en-US");
            Workbooks workbooks = xlApp.Workbooks;
            Workbook workbook = workbooks.Add(XlWBATemplate.xlWBATWorksheet);
            Worksheet worksheet = workbook.Worksheets[1];
            Range range;
            long totalCount = dt.Rows.Count;
            long rowRead = 0;
            long percent = 0;
            for (int i = 0; i < dt.Columns.Count; i++)
            {
                worksheet.Cells[1, i + 1] = dt.Columns[i].ColumnName;
                range = worksheet.Cells[1, i + 1];
                range.Interior.ColorIndex = 15;
            }
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                for (int j = 0; j < dt.Columns.Count; j++)
                {
                    try
                    {
                        worksheet.Cells[i + 2, j + 1] = dt.Rows[i][j].ToString();
                    }
                    catch 
                    {
                        worksheet.Cells[i + 2, j + 1] = dt.Rows[i][j].ToString().Replace("=", "");
                    }
                }
                rowRead++;
                percent = (100 * rowRead) / totalCount;
            }
            worksheet.Columns.EntireColumn.AutoFit();//列宽自适应
            worksheet.Shapes.AddTextEffect(MsoPresetTextEffect.msoTextEffect1, " ", "Red", 15, MsoTriState.msoFalse, MsoTriState.msoTrue, 150, 200);
            xlApp.Visible = true;
        }
    }
}
