﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows.Forms;

namespace SearchWordFromJavaTool
{
    static class ReadAndSearch
    {
        public static void RAS(string searchStr, string path, string type)
        {
            List<ContentEntity> orgList = FileAndFloderTools.GetInfoIncludeSearchStr(path, searchStr, type);
            Dictionary<string, int> dic = new Dictionary<string, int>();
            foreach (ContentEntity item in orgList)
            {
                string key = item.PaOrns + "_" + item.FileName + "_";
                if (dic.Keys.Contains(key))
                    dic[key] += 1;
                else
                    dic.Add(key, item.UseCount);
            }
            List<ContentEntity> newList = new List<ContentEntity>();
            ContentEntity ce;
            foreach (var item in dic)
            {
                ce = new ContentEntity()
                {
                    PaOrns = Match.GetPaOrNs(item.Key),
                    FileName = Match.GetFileName(item.Key),
                    UseCount = item.Value
                };
                newList.Add(ce);
            }

            DataTable dt = new DataTable();
            dt.Columns.Add("PackAgeOrNameSpace", typeof(string));
            dt.Columns.Add("FileName", typeof(string));
            dt.Columns.Add("Count", typeof(int));

            DataRow dr;
            foreach (var item in newList)
            {
                dr = dt.NewRow();
                dr["PackAgeOrNameSpace"] = item.PaOrns;
                dr["FileName"] = item.FileName;
                dr["Count"] = item.UseCount;
                dt.Rows.Add(dr);
                dt.AcceptChanges();
            }

            ExcelHelper.ExportExcel(dt);
        }
    }
}
